/****************************************************************************
    BSch3V schematic capture
    Copyright (C) 1997-2014 H.Okada
*****************************************************************************/

#ifndef COMPLIB_H
#define COMPLIB_H

#include "coord.h"

#include "SPtnObj.h"
#include "SPtnObjArc.h"
#include "SPtnObjCircle.h"
#include "SPtnObjLine.h"
#include "SPtnObjPolygon.h"
#include "SPtnObjText.h"


class SReadCE3;
class SWriteCE3;

#ifdef _BSCH
	extern bool g_notSaveBitPtn;
#endif

#define PIN_LENGTH 10


////////////////////////////////////////////////////////////////////
//iCuɊ֌W`


enum PIN_TYPE
{
	PIN_TYPE_NOMAL		=0x00,
	PIN_TYPE_SMALL		=0x01,
	PIN_TYPE_ZLENG		=0x02,
	PIN_TYPE_CLOCK		=0x04,
	PIN_TYPE_NEGATIVE	=0x08,
	PIN_TYPE_NUMHIDE	=0x10
};

enum PIN_LOC
{
	PIN_LOC_L			=0x0,
	PIN_LOC_T			=0x1,
	PIN_LOC_R			=0x2,
	PIN_LOC_B			=0x3
};
/*
enum VECTPTN
{
	VECTPTN_L			=1,
	VECTPTN_C			=2,
	VECTPTN_PG			=3,
	VECTPTN_AR			=4
};
*/



typedef SPtnObj* PSPtnObj;
typedef list<SPtnObj*> SPtnObjList;
typedef list<SPtnObj*>::iterator SPtnObjListIterator;

//LB3Cu̓ǂݍ݂Ŏgp^[NX
class SPtn
{
protected:
	unsigned char* readBmp(SReadCE3& rce3);//,int x,int y,int nBuffSize);
	//bool readLine(SReadCE3& rce3,int* vBuff,int vBuffCount,int* count);
	//bool readCircle(SReadCE3& rce3,int* vBuff,int vBuffCount,int* count);
	//bool readCircleFill(SReadCE3& rce3,int* vBuff,int vBuffCount,int* count);
	//bool readArc(SReadCE3& rce3,int* vBuff,int vBuffCount,int* count);
	//bool readPolygon(SReadCE3& rce3,int* vBuff,int vBuffCount,int* count);

	//bool writeLine(SWriteCE3& wce3,int* buff,int* count);
	//bool writeCircle(SWriteCE3& wce3,int* buff,int* count);
	//bool writeCircleFill(SWriteCE3& wce3,int* buff,int* count);
	//bool writeArc(SWriteCE3& wce3,int* buff,int* count);
	//bool writePolygon(SWriteCE3& wce3,int* buff,int* count);


public:
	TCHAR*			m_pszName;		//p^[
	SSize			m_size;			//TCY
	int				m_nBuffsize;	//obt@̃TCY
	PSPtnObj*		m_ppvPtn;		//xNgp^[IuWFNg̃|C^z
	int				m_vPtnCount;
	unsigned char*	m_pBuff;		//obt@ւ̃|C^
//	int*			m_pvBuff;		//xNg`ւ̃|C^
//	int				m_nvBuffsize;	//xNg`̃obt@̃TCY

	SPtn(){							//RXgN^
		m_pszName=NULL;
		m_nBuffsize=0;
		m_pBuff=NULL;
//		m_nvBuffsize=0;
//		m_pvBuff=NULL;
		m_size=SSize(0,0);
		m_vPtnCount=0;
		m_ppvPtn=NULL;
	}

	SPtn(const SPtn&);				//Rs[RXgN^
	SPtn& operator=(const SPtn&);	//Zq	

	virtual ~SPtn();				//fXgN^
	bool readCe3(SReadCE3& rce3);
	bool writeCe3(SWriteCE3& wce3,LPCTSTR pszName);
	void setSize(const SSize& sizePixel);
};



////////////////////////////////////////////////////////////////////
//sNX̒`
class SPin
{
protected:
	int			m_nBlock;	//m_nBlock̐sԍzǗĂ
	TCHAR**		m_ppszNum;	//sԍzւ̃|C^
	TCHAR*		m_pszName;	//sւ̃|C^
	int			m_nType;	//s̃^Cv
	int			m_nLTRB;	//ʒu LTRB
	int			m_nOffset;	//ʒu ItZbg
	unsigned long m_pinNameDisplayFlag; //sʕ\tO
	unsigned	m_flags;	//t@CɕۑȂ쎞̃tO

	enum{
		FLAGS_NC = 0x0001
	};

	//bool m_pinNameDrawCache;
	TCHAR*	m_pszPinNameDraw;



protected:
	void deleteBuff();

public:
	SPin();					//RXgN^
	~SPin();
	SPin(const SPin&);				//Rs[RXgN^
	SPin& operator=(const SPin&);	//Zq

	void SetPinNameDisplayFlag(unsigned long val){m_pinNameDisplayFlag = val;}
	unsigned long GetPinNameDisplayFlag(void ){return m_pinNameDisplayFlag;}

	
	void setBlock(int  nBlock);	//ubNZbgB
	void setPinName(const TCHAR* name);				//sZbgB
	void setPinNum(int nBlock,const TCHAR* name);	//sԍZbgB
	void setType(int type){ m_nType=type;}
	void setLtrb(int ltrb){ m_nLTRB=ltrb;}
	void setOffset(int offset){m_nOffset=offset;}
	const TCHAR* pinName() const {return m_pszName;}
	const TCHAR* pinNameDraw() const {return m_pszPinNameDraw;}
	const TCHAR* pinNum(int nBlock) const;
	int type() const {return m_nType;}
	int ltrb() const {return m_nLTRB;}
	int offset() const {return m_nOffset;}
	int block() const { return m_nBlock;}

	bool nc() const { return m_flags &  FLAGS_NC;}
	void set_nc(bool itisNC);

	void setupPinNameDraw();

	bool readCe3(SReadCE3& rce3,int block);
	bool writeCe3(SWriteCE3& rce3);
};

typedef SPin* PSPin;

typedef list<SPin*> SPinList;
typedef list<SPin*>::iterator SPinListIterator;


////////////////////////////////////////////////////////////////////
//iNX̒`
class SCompInfo
{
protected:
	void deleteBuff();

public:
	enum CITYPE{
		GENERAL			= 0,
		SHARED_BLOCK	= 1,	//ɕubN̕iƈꏏɎg鋤ʕAIyAvA74WbN̓dA[̃RCAXCb`̏ƌ
		FIXED_BLOCK		= 2		//
	};

public:
	TCHAR*	m_pszRef;	//ftHgiԍ
	SSize	m_size;		//ĩTCY
	int		m_nBlock;	//pbP[W̃ubN
	int		m_nFixedBlock; //ŒubN
	CITYPE	m_ciType;	
	SPtn*	m_pPtn;		//LB3ǂݍ񂾃p^[ւ̃|C^
	int		m_nPinCount;//s
	PSPin*	m_ppPin;	//LB3ǂݍ񂾃sNX̔zւ̃|C^
	wstring	m_note;		//m[g 2005/04/30
	wstring	m_mfr;		//ҋL 2009/02/01
	wstring	m_mfrpn;	//Ҍ^L 2009/02/01
	wstring	m_pkg;		//pbP[WL 2009/02/01

	SCompInfo(){		//RXgN^
		m_pszRef	=NULL;
		m_nBlock	=1;
		m_pPtn		=NULL;
		m_nPinCount	=0;
		m_ppPin		=NULL;
		m_note		=_T("");
		m_mfr		=_T("");
		m_mfrpn		=_T("");
		m_pkg		=_T("");
		m_nFixedBlock = 0;
		m_ciType	= CITYPE::GENERAL;
	}
	~SCompInfo();			//fXgN^

	SCompInfo(const SCompInfo&);			//Rs[RXgN^
	SCompInfo& operator=(const SCompInfo&);	//Zq

	bool readCe3(SReadCE3& rce3,wstring& name,wstring& ptnname);	//t@C̓ǂݍ
	bool writeCe3(SWriteCE3& wce3,const TCHAR* pszName);

	void setCiType(CITYPE citype);
	void setRef(const TCHAR* ref);		//ftHgiԍ̐ݒ
	void setSize(const SSize& size,bool createPtn);	//TCY̐ݒ p^[Lꍇ̓p^[̃TCYύX
	void setUsePattern(bool usepattern);
	void setBlock(int block);
	void setFixedBlock(int fb);
	void addPin(SPin* ppin);
	void removePin(int ltrb,int offset,bool move);
	void insertNullPin(int ltrb,int offset);
	SPin* pinInfo(int ltrb,int offset);	//w肵ʒũs𓾂
};

////////////////////////////////////////////////////////////////////
//iCfbNXNX̒`
class SCompIndex
{
	TCHAR*				m_lpszName;	//i
public:
	SCompInfo*			m_pCompInfo;//Ή镔iNXւ̃|C^

	SCompIndex(){			//RXgN^
		m_lpszName	=NULL;
		m_pCompInfo =NULL;
	}
	~SCompIndex(){			//fXgN^
		delete[]m_lpszName;
	}
	void setName(const TCHAR* name);
	void setCompInfo(SCompInfo* pcinfo){m_pCompInfo = pcinfo;}

	SCompInfo* compInfo() const{return m_pCompInfo;}
	const TCHAR*	name() const{return m_lpszName;}			//i𓾂
	const TCHAR* number() const;			//iԍ𓾂

	const TCHAR* Mfr() const;			//҂𓾂		20090203
	const TCHAR* MfrPn() const;			//Ҍ^𓾂		20090203
	const TCHAR* Pkg() const;			//pbP[W𓾂		20090203

	SSize size() const;					//TCY𓾂
	SSize sizePlace(int dir) const;		//zu̐}ʏ̃TCY𓾂
	int	  block() const;				//pbP[W̃ubN𓾂
	SPtn*	pattern() const;			//p^[ւ̃|C^𓾂
	int	pinCount() const;				//s̐𓾂
	SPin* pin(int index) const;			//s̏𓾂
	//s̏𓾂
	//̏񂩂As̈ʒu(LTRBƁA_̃ItZbg)Ԃ
	SPin* pin(int index,int dir,int& nLtrb,SPoint& ptLoc) const;

};



typedef SCompIndex* PSCompIndex;

typedef list<SPtn*> SPtnList;
typedef list<SPtn*>::iterator SPtnListIterator;

typedef list<SCompInfo*> SCompInfoList;
typedef list<SCompInfo*>::iterator SCompInfoListIterator;

typedef list<SCompIndex*> SCompIndexList;
typedef list<SCompIndex*>::iterator SCompIndexListIterator;


////////////////////////////////////////////////////////////////////
//iCuNX
class SCompLib
{
public:
	LPTSTR			m_lpszLibraryName;		//Cu
	wstring			m_prop_string;
	SPtnList		m_listPtn;				//ǂݍ񂾃p^[̃Xg
	SCompInfoList	m_listCompInfo;			//ǂݍݍ񂾕iNX̃Xg
	SCompIndexList	m_listCompIndex;		//ǂݍݍ񂾕iCfbNX̃Xg
	PSCompIndex*	m_ppCompIndex;			//ǂݍݍ񂾕iCfbNX̃|C^z
	int				m_aux1;
	int				m_aux2;

	int				m_dataVersion;			//Version 0.80
static const int m_nConstDataVersion = 82;	//Version 0.80 Cuf[^̃o[W



public:
	SCompLib(){										//RXgN^
		m_lpszLibraryName=NULL;
		m_ppCompIndex=NULL;
		m_prop_string=_T("");
		m_aux1 = 0;
		m_aux2 = 0;
		m_dataVersion = m_nConstDataVersion;
		//m_nCount=0;
	}
	~SCompLib();										//fXgN^
	bool ReadLb3(SReadCE3& rce3,bool singleComponent = false);//LB3Cu̓ǂݍ
	void deleteContent();//e̔j

	bool writeLibraryFile(LPCTSTR lpszFileName);	//t@C
	bool readLibraryFile(LPCTSTR lpszFileName);		//t@Cǂݍ

	void setLibraryName(LPCTSTR name);				//Cu̐ݒ
	LPCTSTR libraryName() const ;					//Cu𓾂
	int count() const{return m_listCompIndex.size();}	//Ǘi𓾂
	SCompIndex* compIndex(int nIndexNum) const;			//nԖڂ̕ĩCfbNX𓾂

	static bool WriteAlias(SWriteCE3& wce3,LPCTSTR  alias,LPCTSTR  name);
	wstring uniqueName(const wstring& name);	//̕iƏdȂȂO

private:
	bool ReadLb3Ptn(SReadCE3& rce3);//p^[̓ǂݍ
	bool ReadLb3Comp(SReadCE3& rce3);
	bool ReadLb3Alias(SReadCE3& rce3);

	void clearPtnList();	//o[ϐp^[Xg̃NA


	bool isUniqueName(const wstring& name);	//̕iƏdĂȂǂ

	//bool WriteLb3Pin(SWriteCE3& wce3,const SPin& pin);							//s̏
	//bool WriteLb3Ptn(SWriteCE3& wce3,const SPtn& ptn,const char*  name);			//p^[̏
	//bool WriteLb3Comp(SWriteCE3& wce3,const SCompInfo& compinfo,SWriteCE3& wce3);	//ȉ
	
};


#endif
